ForInLoop (rhino 1.7.14 API)

org.mozilla.javascript.ast

## Class ForInLoop

- java.lang.Object
- - org.mozilla.javascript.Node
  - - org.mozilla.javascript.ast.AstNode
    - - org.mozilla.javascript.ast.Jump
      - - org.mozilla.javascript.ast.Scope
        - - org.mozilla.javascript.ast.Loop
          - - org.mozilla.javascript.ast.ForInLoop

- All Implemented Interfaces:
    java.lang.Comparable<AstNode>, java.lang.Iterable<Node>
  Direct Known Subclasses:
    ArrayComprehensionLoop, GeneratorExpressionLoop

      public class ForInLoop
      extends Loop

  For-in or for-each-in or for-of statement. Node type is `Token.FOR`.

      for [each] ( LeftHandSideExpression in Expression ) Statement

      for [each] ( var VariableDeclarationNoIn in Expression ) Statement

      for ( LeftHandSideExpression of Expression ) Statement

      for ( ForDeclaration of Expression ) Statement

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode

      `AstNode.DebugPrintVisitor, AstNode.PositionComparator`

    - ### Nested classes/interfaces inherited from class org.mozilla.javascript.Node

      `Node.NodeIterator`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `eachPosition`
    `protected int` | `inPosition`
    `protected boolean` | `isForEach`
    `protected boolean` | `isForOf`
    `protected AstNode` | `iteratedObject`
    `protected AstNode` | `iterator`

    - ### Fields inherited from class org.mozilla.javascript.ast.Loop

      `body, lp, rp`

    - ### Fields inherited from class org.mozilla.javascript.ast.Scope

      `parentScope, symbolTable, top`

    - ### Fields inherited from class org.mozilla.javascript.ast.Jump

      `target`

    - ### Fields inherited from class org.mozilla.javascript.ast.AstNode

      `inlineComment, length, parent, position`

    - ### Fields inherited from class org.mozilla.javascript.Node

      `ARROW_FUNCTION_PROP, ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SHORTHAND_PROPERTY_NAME, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, TEMPLATE_LITERAL_PROP, type, VARIABLE_PROP`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ForInLoop()`
    `ForInLoop(int pos)`
    `ForInLoop(int pos, int len)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getEachPosition()` Returns position of "each" keyword
    `int` | `getInPosition()` Returns position of "in" or "of" keyword
    `AstNode` | `getIteratedObject()` Returns object being iterated over
    `AstNode` | `getIterator()` Returns loop iterator expression
    `boolean` | `isForEach()` Returns whether the loop is a for-each loop
    `boolean` | `isForOf()` Returns whether the loop is a for-of loop
    `void` | `setEachPosition(int eachPosition)` Sets position of "each" keyword
    `void` | `setInPosition(int inPosition)` Sets position of "in" or "of" keyword
    `void` | `setIsForEach(boolean isForEach)` Sets whether the loop is a for-each loop
    `void` | `setIsForOf(boolean isForOf)` Sets whether the loop is a for-each loop
    `void` | `setIteratedObject(AstNode object)` Sets object being iterated over, and sets its parent to this node.
    `void` | `setIterator(AstNode iterator)` Sets loop iterator expression: the part before the "in" or "of" keyword.
    `java.lang.String` | `toSource(int depth)` Emits source code for this node.
    `void` | `visit(NodeVisitor v)` Visits this node, the iterator, the iterated object, and the body.

    - ### Methods inherited from class org.mozilla.javascript.ast.Loop

      `getBody, getLp, getRp, setBody, setLp, setParens, setRp`

    - ### Methods inherited from class org.mozilla.javascript.ast.Scope

      `addChildScope, clearParentScope, getChildScopes, getDefiningScope, getParentScope, getStatements, getSymbol, getSymbolTable, getTop, joinScopes, putSymbol, replaceWith, setParentScope, setSymbolTable, setTop, splitScope`

    - ### Methods inherited from class org.mozilla.javascript.ast.Jump

      `getContinue, getDefault, getFinally, getJumpStatement, getLoop, setContinue, setDefault, setFinally, setJumpStatement, setLoop`

    - ### Methods inherited from class org.mozilla.javascript.ast.AstNode

      `addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getInlineComment, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setInlineComment, setLength, setParent, setPosition, setRelative, shortName, toSource`

    - ### Methods inherited from class org.mozilla.javascript.Node

      `addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getBigInt, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getJsDocNode, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, resetTargets, setBigInt, setDouble, setJsDocNode, setLineno, setScope, setString, setType, toString, toStringTree`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

- - ### Field Detail

    - #### iterator

          protected AstNode iterator

    - #### iteratedObject

          protected AstNode iteratedObject

    - #### inPosition

          protected int inPosition

    - #### eachPosition

          protected int eachPosition

    - #### isForEach

          protected boolean isForEach

    - #### isForOf

          protected boolean isForOf

  - ### Constructor Detail

    - #### ForInLoop

          public ForInLoop()

    - #### ForInLoop

          public ForInLoop(int pos)

    - #### ForInLoop

          public ForInLoop(int pos,
                           int len)

  - ### Method Detail

    - #### getIterator

          public AstNode getIterator()

      Returns loop iterator expression

    - #### setIterator

          public void setIterator(AstNode iterator)

      Sets loop iterator expression: the part before the "in" or "of" keyword. Also sets its parent to this node.
      Throws:
        `java.lang.IllegalArgumentException` - if `iterator` is `null`

    - #### getIteratedObject

          public AstNode getIteratedObject()

      Returns object being iterated over

    - #### setIteratedObject

          public void setIteratedObject(AstNode object)

      Sets object being iterated over, and sets its parent to this node.
      Throws:
        `java.lang.IllegalArgumentException` - if `object` is `null`

    - #### isForEach

          public boolean isForEach()

      Returns whether the loop is a for-each loop

    - #### setIsForEach

          public void setIsForEach(boolean isForEach)

      Sets whether the loop is a for-each loop

    - #### isForOf

          public boolean isForOf()

      Returns whether the loop is a for-of loop

    - #### setIsForOf

          public void setIsForOf(boolean isForOf)

      Sets whether the loop is a for-each loop

    - #### getInPosition

          public int getInPosition()

      Returns position of "in" or "of" keyword

    - #### setInPosition

          public void setInPosition(int inPosition)

      Sets position of "in" or "of" keyword
      Parameters:
        `inPosition` - position of "in" or "of" keyword, or -1 if not present (e.g. in presence of a syntax error)

    - #### getEachPosition

          public int getEachPosition()

      Returns position of "each" keyword

    - #### setEachPosition

          public void setEachPosition(int eachPosition)

      Sets position of "each" keyword
      Parameters:
        `eachPosition` - position of "each" keyword, or -1 if not present.

    - #### toSource

          public java.lang.String toSource(int depth)

      Description copied from class: `AstNode`
      Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

      Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

      Overrides:
        `toSource` in class `Scope`
      Parameters:
        `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

    - #### visit

          public void visit(NodeVisitor v)

      Visits this node, the iterator, the iterated object, and the body.
      Overrides:
        `visit` in class `Scope`
      Parameters:
        `v` - the object to call with this node and its children